hotel('A - Hilton', 32,15,2500, 5).

hotel('B - Carlton',27, 6,1500, 3).
hotel('C - Jalta',  24, 3, 500, 6).
hotel('D - Druzba', 20, 8, 350,10).
hotel('E - Gerlach',16,20,1000,10).
hotel('F - Park',   10, 5, 350,15).
hotel('G - Dukla',   5,15, 500,17).
hotel('H - Ritz',    4,10,1500, 2).
hotel('I - Tatry',   6, 5, 400, 9).
hotel('J - Hutnik',  7, 8, 500,20).
hotel('K - Anca',   15, 2, 320, 1).
hotel('L - Slovan', 18,10, 500, 6).
hotel('M - Soviet', 13,20, 300,20).

stredneVysoky(20,0.1).
stredneVysoky(15,0.1).
stredneVysoky(10,0.7).
stredneVysoky(8,0.8).
stredneVysoky(6,0.9).
stredneVysoky(5,0.9).
stredneVysoky(3,0.1).
stredneVysoky(2,0.1).

blizkoBanky(32,0.2).
blizkoBanky(27,0.2).
blizkoBanky(24,0.2).
blizkoBanky(20,0.3).
blizkoBanky(18,0.4).
blizkoBanky(16,0.5).
blizkoBanky(15,0.5).
blizkoBanky(13,0.6).
blizkoBanky(10,0.6).
blizkoBanky(8,0.75).
blizkoBanky(7,0.7).
blizkoBanky(6,0.7).
blizkoBanky(5,0.8).
blizkoBanky(4,0.9).
blizkoBanky(2,0.9).

member([H|T],H).
member([H|T],A):-member(T,A).

notin([],A).
notin([H|T],A):-not member([H|T],A).


vytvor(L,V):-blizkoBanky(A,PH),notin(L,A),vytvor([A|L],V).
vytvor(L,L):-!.

%min(A,ROZDIEL,C):-blizkoBanky(B,C),abs(A-B)<ROZDIEL,not(A=B),min(A,abs(A-B),C).
%min(A,ROZDIEL,C):-blizkoBanky(B,C),abs(A-B)>=ROZDIEL,min(A,ROZDIEL,C).

stary(20,1).
stary(17,1).
stary(15,1).
stary(12,0.8).
stary(10,0.7).
stary(9,0.6).
stary(6,0.5).
stary(5,0.5).
stary(4,0.3).
stary(3,0.2).
stary(2,0.1).
stary(1,0.1).

slusnaCena(200,0.8).
slusnaCena(300,0.7).
slusnaCena(400,0.6).
slusnaCena(500,0.5).
slusnaCena(600,0.4).
slusnaCena(800,0.4).
slusnaCena(1000,0.35).
slusnaCena(1200,0.3).
slusnaCena(1700,0.1).
slusnaCena(2000,0.1).

stredneVysokyBlizkoBanky(HOTEL,PH):-hotel(HOTEL,VZDIAL,VYSKA,_,_),blizkoBanky(VZDIAL,PH1),stredneVysoky(VYSKA,PH2),PH is (4*PH1+3*PH2)/7.
stredneVysokyBlizkoBankyPrah(HOTEL,PH,PRAH):-hotel(HOTEL,VZDIAL,VYSKA,_,_),blizkoBanky(VZDIAL,PH1),stredneVysoky(VYSKA,PH2),PH is (4*PH1+3*PH2)/7, PH>PRAH.