#!C:\Python22\python.exe
import MySQLdb, cgi

print 'Content-type: plain/text'
print
print '<body bgcolor=silver><pre>'

# --- praca s databazou ---
# Create a connection object and create a cursor
_h, _p, _u, _s, _d='salvia.intrak.upjs.sk',3306, 'user', '', 'test'
Con = MySQLdb.Connect(host=_h, port=_p, user=_u, passwd=_s, db=_d)
Cursor = Con.cursor()

print 'Connected to <b>'+_h+':'+`_p`+'</b> as <i>'+ _u+'</i> using '+_d+'<br/>'

# vyrobim sql string a vykonam ho
sql = "SELECT * FROM hotely"
count = Cursor.execute(sql)

# fetchnem vsetky vysledky z kurzora do sekvencie & zatvorim spojenie
results = Cursor.fetchall()
Con.close()
# --- dalej uz databazy necham tak, data mam v tuple ---

# upravim si vstup podla obsahu v prvom stlpci, aby sa mi lepsie pracovalo
hotely = {}
for h in results:
     hotely[h[0]] = h[1:]

# ---- teraz idem robit s cgi
# ---- nacitam vstupne data a pripravim si funkcie close, r_price, age_r

form = cgi.FieldStorage()

# --- blizko
def close(x):
    l = float(form.getfirst("ldistance"))
    u = float(form.getfirst("udistance"))
    return min(1, max(0, 1-((x-l)/(u-l))))

# --- lacny
def reasonable_price(x):
    l = float(form.getfirst("lprice"))
    u = float(form.getfirst("uprice"))
    return min(1, max(0, 1-((x-l)/(u-l))))

# --- novy
def age_reasonable(x):
    l = float(form.getfirst("lage"))
    u = float(form.getfirst("uage"))
    return min(1, max(0, 1-((2000-x-l)/(u-l))))

# --- agregator
def a(x, y, z):
    vp,vd,va = int(form.getfirst("iprice")),int(form.getfirst("idistance")),int(form.getfirst("iage"))
    return (vp*reasonable_price(x)+vd*close(y)+va*age_reasonable(z))/float(vp+vd+va)

# --- spravime agregaciu nad vyratanymi hodnotami
s = [ (a(hotely[h][0],hotely[h][1],hotely[h][2]), h) for h in hotely.keys() ]
s.sort(); s.reverse()

print '--- <B><I>SQL: '+sql+'</I></B> '+'-'*12
print '<B>  %-10s%10s%10s%10s</B>' % ('Nazov','Cena','KM','Rok')
for k in hotely.keys():
    print '  <I>%-10s</I>%10d%10d%10d' % (k, hotely[k][0], hotely[k][1], hotely[k][2])

# --- medzivysledok pisem, iba ak to user zaskrtne
if form.getfirst("inter"):
    print '\n--- <B><I>Medzikrok vypoctu</I></B> '+'-'*20
    print '<B>  %-10s%10s%10s%10s</B>' % ('Nazov','Cena','KM','Rok')
    for k in hotely.keys():
        print '  <I>%-10s</I>%10.5f%10.5f%10.5f' % (k, reasonable_price(hotely[k][0]), close(hotely[k][1]), age_reasonable(hotely[k][2]))

# --- treba spracovat druh vysledku, ktory zvolil user
cut = form.getfirst("cut")
print '\n--- <B><I>Vysledok</I></B> '+'-'*29
print '<B>  %-10s%10s%10s</B>' % ('Nazov','PH', 'Rating')
if cut == 'b':		# vypise najlepis vysledok
     print '  <I>%-10s</I>%10.5f   ' % (s[0][1], s[0][0]),
     print '*'*(int(round(10*s[0][0])))
elif cut=='n':		# vypise best najlepsich odpovedi
     best = int(form.getfirst("best"))
     for x in s:
         if best==0:
              break
         best-=1
         print '  <I>%-10s</I>%10.5f   ' % (x[1], x[0]),
         print '*'*(int(round(10*x[0])))
elif cut=='t':		# vypise odpovede, ktorych ph je >= th
     th = float(form.getfirst("th"))
     for x in s:
         if x[0]>=th:
              print '  <I>%-10s</I>%10.5f   ' % (x[1], x[0]),
              print '*'*(int(round(10*x[0])))
elif cut=='a':		# vypise vsetky
     for x in s:
         print '  <I>%-10s</I>%10.5f   ' % (x[1], x[0]),
         print '*'*(int(round(10*x[0])))
elif cut=='e':
     eps = float(form.getfirst("e"))
     yps = float(form.getfirst("y"))
     for x in s:
         if abs(yps-x[0])<=eps:
              print '  <I>%-10s</I>%10.5f   ' % (x[1], x[0]),
              print '*'*(int(round(10*x[0])))

print '\n<A HREF="/index.html">spat</A>'
print '</pre></body>'