
rodic(jozo,maria,0.7).
rodic(jozo,juraj,0.8).
rodic(alena,maria,0.9).
rodic(alena,juraj,0.9).
rodic(maria,jano,0.85).
rodic(maria,zuzana,1).
rodic(julo,jano,0.95).
rodic(julo,zuzana,0.9).
rodic(juraj,martina,0.1).
rodic(juraj,peter,0.2).
rodic(lucia,martina,0.7).
rodic(lucia,peter,0.9).
muz(jozo,1).
muz(jano,1).
muz(julo,1).
muz(juraj,0.8).
muz(peter,1).
zena(maria,1).
zena(alena,1).
zena(zuzana,1).
zena(martina,1).
zena(lucia,1).

%pravidla

otec(X,Y,P):-otec(X,Y,0.9,P).
otec(X,Y,0.9,P):-rodic(X,Y,PR),muz(X,PM),compcf([PR,PM,0.9],P). 

matka(X,Y,P):-matka(X,Y,1,P).
matka(X,Y,1,P):-rodic(X,Y,PR),zena(X,PZ),compcf([PR,PZ,1],P).

dcera(X,Y,P):-dcera(X,Y,1,P).
dcera(X,Y,1,P):-rodic(Y,X,PR),zena(X,PZ),compcf([PR,PZ,1],P).


syn(X,Y,P):-syn(X,Y,1,P).
syn(X,Y,1,P):-rodic(Y,X,PR),muz(X,PM),compcf([PR,PM],1,P).

sesternica(X,Y,P):-sesternica(X,Y,1,P).
%sesternica(X,Y,1,P):-rodic(Z,X,PR1),rodic(T,Z,PR2),rodic(T,U,PR3),Z\=U,rodic(U,Y,PR4),zena(X,PM),konjg(PR1,PR2,P2),konjg(P2,PR3,P3),konjg(P3,PR4,P4),konjg(P4,PM,P1),c(P1,1,P).
sesternica(X,Y,1,P):-rodic(Z,X,PR1),rodic(T,Z,PR2),rodic(T,U,PR3),Z\=U,rodic(U,Y,PR4),zena(X,PZ),compcf([PR1,PR2,PR3,PR4,PZ,1],P).

bratranec(X,Y,P):-bratranec(X,Y,1,P).
%bratranec(X,Y,1,P):-rodic(Z,X,PR1),rodic(T,Z,PR2),rodic(T,U,PR3),Z\=U,rodic(U,Y,PR4),muz(X,PM),konjg(PR1,PR2,P2),konjg(P2,PR3,P3),konjg(P3,PR4,P4),konjg(P4,PM,P1),c(P1,1,P).
bratranec(X,Y,1,P):-rodic(Z,X,PR1),rodic(T,Z,PR2),rodic(T,U,PR3),Z\=U,rodic(U,Y,PR4),muz(X,PM),compcf([PR1,PR2,PR3,PR4,PM,1],P).

max(X,Y,Z):-X>Y,Z is X.
max(X,Y,Z):-X<Y,Z is Y.
min(X,Y,Z):-max(X,Y,Z1), Z is X+Y-Z1.


konjl(P1,P2,P):-max(P1+P2-1,0,P).
konjp(P1,P2,P):-P is X*Y.
konjg(P1,P2,P):-min(P1,P2,P).
disjl(P1,P2,P):-min(1,P1+P2,P).
disjp(P1,P2,P):-P is P1+P2-P1*P2.
disjg(P1,P2,P):-max(P1,P2,P).
c(P1,P2,P):-konjl(P1,P2,P).

computecf(P1,P2,PC,P):-konjg(P1,P2,PM1),c(PM1,PC,P).
compcf([]).
compcf([H1|T1],P):-compcf1(H1,T1,P).
compcf1(_,[],_).
compcf1(H,[A],P):-c(H,A,P).
compcf1(H1,[H2|T2],P):-konjg(H1,H2,PM1),list(T2),compcf1(PM1,T2,P).
