% hotel(meno,vzdialenost od stanice v min, pocet parkovacich miest, cena za noc, vek hotela)

hotel('Banik', 25,50,500, 5).
hotel('Carlton',42, 163,2500, 3).
hotel('Jalta',  14, 56, 300, 6).
hotel('Druzba', 10, 0, 350,10).
hotel('Robotnik',31,20,100,10).
hotel('Park',   50, 50, 1350,15).
hotel('Dukla',   5,35, 600,17).
hotel('Rozkvet', 24,100,1800, 2).
hotel('Grand',   8, 200, 900, 9).
hotel('Chemik',  62, 20, 300,20).
hotel('Hubertus',   19, 42, 3500, 1).
hotel('Bratislava', 18,100, 2500, 6).
hotel('Kyjev', 19,60, 2300,20).


dostatocnypocetparkmiest(163,0.9).
dostatocnypocetparkmiest(56,0.5).
dostatocnypocetparkmiest(0,0.8).
dostatocnypocetparkmiest(20,0.3).
dostatocnypocetparkmiest(50,0.5).
dostatocnypocetparkmiest(35,0.4).
dostatocnypocetparkmiest(100,0.8).
dostatocnypocetparkmiest(200,0.9).
dostatocnypocetparkmiest(42,0.4).
dostatocnypocetparkmiest(60,0.1).

blizkoStanice(25,0.5).
blizkoStanice(42,0.2).
blizkoStanice(14,0.8).
blizkoStanice(10,0.8).
blizkoStanice(31,0.4).
blizkoStanice(50,0.1).
blizkoStanice(5,0.9).
blizkoStanice(24,0.5).
blizkoStanice(8,0.9).
blizkoStanice(62,0.1).
blizkoStanice(19,0.7).
blizkoStanice(18,0.7).


stary(20,1).
stary(17,1).
stary(15,1).
stary(12,0.8).
stary(10,0.7).
stary(9,0.6).
stary(6,0.5).
stary(5,0.5).
stary(4,0.3).
stary(3,0.2).
stary(2,0.1).
stary(1,0.1).

dobraCena(500,0.8).
dobraCena(300,0.9).
dobraCena(350,0.9).
dobraCena(100,0.7).
dobraCena(1350,0.4).
dobraCena(600,0.8).
dobraCena(1800,0.3).
dobraCena(900,0.7).
dobraCena(3500,0.1).
dobraCena(2500,0.2).
dobraCena(2300,0.2).

query(HOTEL,PH,K1,K2,K3):-hotel(HOTEL,VZDIAL,MIEST,CENA,_),blizkoStanice(VZDIAL,PH1),dostatocnypocetparkmiest(MIEST,PH2),dobraCena(CENA,PH3),PH is (K1*PH1+K2*PH2+K3*PH3)/(K1+K2+K3).