:-load(list).
:-import(list).

hotel(slovan, 150, 1200, 1998).
hotel(forum, 200, 1000, 1989).
hotel(hoges, 950, 500, 1995).
hotel(elektra, 1000, 750, 1985).
hotel(dukla, 960, 520, 1997).
hotel(baracka, 420, 600, 2000).

vzdialenost(Vstup,Hod,Vystup):-Hod < Vstup, Vystup is 1.        
vzdialenost(Vstup,Hod,Vystup):-(Hod>Vstup;Hod=Vstup),Vystup is Vstup/Hod.

cena(Vstup,Hod,Vystup):-Hod < Vstup, Vystup is 1.        
cena(Vstup,Hod,Vystup):-(Hod>Vstup;Hod=Vstup),Vystup is Vstup/Hod.

vek(Vstup,Hod,Vystup):-Hod > Vstup, Vystup is 1.        
vek(Vstup,Hod,Vystup):-(Hod<Vstup;Hod=Vstup),Vystup is Hod/Vstup.

hladaj(Meno,Cena,Vzd,Vek,H,K1,K2,K3):-hotel(Meno,Cena1,Vzd1,Vek1), cena(Cena,Cena1,H1), vzdialenost(Vzd,Vzd1,H2), vek(Vek,Vek1,H3), H is ((K1*H1+K2*H2+K3*H3)/(K1+K2+K3)).

najlepsie(ziadny,Cena,Vzd,Vek,0,K1,K2,K3,[]).
najlepsie(A,Cena,Vzd,Vek,V1,K1,K2,K3,[A|B]):-najlepsie(T,Cena,Vzd,Vek,V2,K1,K2,K3,B),hladaj(A,Cena,Vzd,Vek,V1,K1,K2,K3),V1>V2.
najlepsie(T,Cena,Vzd,Vek,V2,K1,K2,K3,[A|B]):-najlepsie(T,Cena,Vzd,Vek,V2,K1,K2,K3,B),hladaj(A,Cena,Vzd,Vek,V1,K1,K2,K3),not(V1>V2).

zoznam(X) :- findall(X, hotel(X, _, _, _), X).

hotely(Meno,Cena,Vzd,Vek,V1,K1,K2,K3):-zoznam(X),najlepsie(Meno,Cena,Vzd,Vek,V1,K1,K2,K3,X).
